﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private streamer As AudioStreamer
End Sub

Sub Service_Create
	streamer.Initialize("streamer", 40000, True, 16, streamer.VOLUME_MUSIC)
	streamer.StartPlaying
End Sub



Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Public Sub Beep (DurationMs As Double, Frequency As Int)
	Dim sampleRate As Int = 40000
	Dim numSamples As Int = sampleRate * DurationMs / 1000
	Dim MaxVal As Short = 32767
	Dim gsnd(2 * numSamples) As Byte
	Dim Fade As Int = (numSamples / 100) * 95
	For i = 0 To numSamples - 1
		If i > Fade Then MaxVal = MaxVal * 0.95
		Dim d As Double = Sin(2 * cPI * i / (sampleRate / Frequency))
		Dim val As Short = d * MaxVal
		gsnd(2 * i) = Bit.And(val, 0x00ff)
		gsnd(2 * i + 1) = Bit.UnsignedShiftRight(Bit.And(val, 0xff00), 8)
	Next
	Log("Beep")
	streamer.Write(gsnd)
End Sub